package com.szpg.rmi;

import com.opensymphony.xwork2.ActionSupport;
import com.szpg.db.dao.*;
import com.szpg.db.dao.impl.*;
import com.szpg.db.data.PgAcu;
import com.szpg.db.data.PgAlarm;
import com.szpg.db.data.PgDevice;
import com.szpg.plc.message.AppMessageConstants;
import com.szpg.plc.message.command.ReadMemoryCommand;
import com.szpg.plc.protocol.fins.FINSConstants;
import com.szpg.plc.server.ACUClient;
import com.szpg.plc.server.ACUClientUtil;
import com.szpg.plc.util.ByteUtil;
import com.szpg.service.ReadControllerStatusService;
import com.szpg.util.Configure;
import com.szpg.util.TimeFormat;
import com.szpg.util.UnicodeConvertor;
import org.apache.log4j.Logger;
import org.apache.struts2.ServletActionContext;
import z.json.JSONObject;

import java.net.URLEncoder;
import java.util.Calendar;

public class RemoteYWCommandAction extends ActionSupport {

	/**
	 * 
	 */
	private static final long serialVersionUID = 2221187086461756012L;

	private String zcbh;
	
	private String format;
	private String jsoncallback;
	
	private Logger logger = Logger.getLogger(this.getClass().getName());
	
	public String getZcbh() {
		return zcbh;
	}

	public void setZcbh(String zcbh) {
		this.zcbh = zcbh;
	}

	public String getFormat() {
		return format;
	}

	public void setFormat(String format) {
		this.format = format;
	}

	public String getJsoncallback() {
		return jsoncallback;
	}

	public void setJsoncallback(String jsoncallback) {
		this.jsoncallback = jsoncallback;
	}
	
	/**
	 * 读取爆管液位实时状态
	 * @return
	 * @throws Exception
	 */
	public String readYwStatus() throws Exception {
		// 返回结果
		JSONObject jResult = new JSONObject();
		
		PgAcuDao acuDao = new PgAcuDaoImpl();
		
		if (null == zcbh || zcbh.equals("") == true) {
			jResult.put("success", false);
			jResult.put("code", "1");
			jResult.put("resaon", UnicodeConvertor.string2Unicode("资产编号为空"));
			
			returnToFront(jResult);
			return null;
		}
		
		String acucode = zcbh.substring(0, zcbh.indexOf(".", 6));
		PgAcu acu = acuDao.findACUByCode(acucode);
		if (null == acu) {
			jResult.put("success", false);
			jResult.put("code", "2");
			jResult.put("resaon", UnicodeConvertor.string2Unicode("未找到资产对应的PLC主机"));
			
			returnToFront(jResult);
			return null;
		}
		
		ACUClient client = ACUClientUtil.getInstance().getClients().get(acu.getAcu_host() + ":" + acu.getAcu_port());
		if (null != client) {
			ReadMemoryCommand command = ReadMemoryCommand.getInstance(AppMessageConstants.CMD_TYPE_READYWSTATUS);
			String sour = Configure.getProperty("sys", "LOCALHOST.NET") + 
						  Configure.getProperty("sys", "LOCALHOST.NODE") + 
						  Configure.getProperty("sys", "LOCALHOST.UNIT");
			command.setMessageProducerId(sour);
			command.setMessageProducerHost(client.getHost());
			
			String dest = client.getNet() + client.getNode() + client.getUnit();
			command.setDestinationId(dest);
			command.setMemoryArea(FINSConstants.MEMORY_WORK_AREA_WORD); //按字读取内容
			
			try {
				// 设置读取的地址范围
				// 从配置文件读取而来
				command.setStartAddress(ByteUtil.binToHexString(ByteUtil.intToBins(Integer.parseInt(Configure.getProperty("acubl", client.getAcucode() + ".YWALM.START")), 2)) + "00");
				command.setCountWord(Integer.parseInt(Configure.getProperty("acubl", client.getAcucode() + ".YWALM.WORDCOUNT")));
				
				// 调用服务过程执行命令发送服务
				ReadControllerStatusService service = new ReadControllerStatusService();
				service.executeService(client, command);
				logger.info(command);
			} catch (Exception ex) {
				logger.error("发送查询爆管液位指令异常" + ex);
			}
			
			jResult.put("success", true);
			jResult.put("resaon", UnicodeConvertor.string2Unicode("发送成功，请等待响应"));
			
			returnToFront(jResult);
			return null;
		} else {
			jResult.put("success", false);
			jResult.put("code", "3");
			jResult.put("resaon", UnicodeConvertor.string2Unicode("PLC主机不在线"));
			
			returnToFront(jResult);
			return null;
		}
	}

	public String readYwStatusFromDB() throws Exception {
		// 返回结果
		JSONObject jResult = new JSONObject();

		PgDeviceDao deviceDao = new PgDeviceDaoImpl();
		PgAlarmDao alarmDao = new PgAlarmDaoImpl();
		PgDevice device = deviceDao.findDeviceByCode(zcbh);
		if (null != device) {
			JSONObject obj = new JSONObject();
			if (null != device.getIsopen() && device.getIsopen().indexOf("爆管") > 0) {
				PgAlarm alarm = alarmDao.findLatestAlarmByDevice(device.getId());
				if (null != alarm) {
					obj.put("alm", null != alarm.getDescription() ? URLEncoder.encode(alarm.getDescription(), "UTF-8") : "");
					obj.put("time", TimeFormat.formatTimestamp(alarm.getAlarm_date()));
				}
			} else {
				obj.put("alm", URLEncoder.encode("正常", "UTF-8"));
				obj.put("time", TimeFormat.formatTimestamp(Calendar.getInstance().getTime()));
			}
			jResult.put("ywStat", obj);
		}

		returnToFront(jResult);
		return null;
	}
	
	/**
	 * 给前端返回
	 * @param jResult
	 * @throws Exception
	 */
	private void returnToFront(JSONObject jResult) throws Exception {
		// 返回jsonp格式的数据
		if (null != format && format.equalsIgnoreCase("jsonp") == true) {
			ServletActionContext.getResponse().getWriter().write(jsoncallback + "(" + jResult.toString() + ");");
		}

		ServletActionContext.getResponse().getWriter().write(jResult.toString());
	}

}
